/*
Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
copyright notice and the following two paragraphs appear in all
copies of this software.

IN NO EVENT SHALL LOBSTERMAN BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, 
SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE 
OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF LOBSTERMAN HAS BEEN 
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

LOBSTERMAN SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" 
BASIS, AND LOBSTERMAN HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, 
UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

Online Documentation for this class can be found at
http://caspar.bgsu.edu/~software/Java/Docs/
*/

package Tests_Tracker;

import com.lobsterman.JavaGrinders.JavaGrinders;
import com.lobsterman.JavaGrinders.Tracker.*;

import java.awt.Color;

/**
 * demo class to control the sequence grabber classes for tracking a red label
 *
 * @author      robert <a href="mailto:lobsterman.bgsu@gmail.com">lobsterman</a> huber
 * @Version	@(#)LabelTracker.java 3/25/07
 */
public class CVTracker_3colLabels {	
     
	static final int 		camID = 0;
	static final int 		cThreshold = -1;
    static final boolean 	toFile = false;
    static final boolean 	toVector = false;
    static final boolean 	toScreen = true;
    static final float 		fps = 30;
	static final int 		secsToRun = 20;

    public static void main (String args[]) {
    try {
    	JavaGrinders.listDetail = true;
    	
		//setup 3 color tracking jobs
		TrackingJobSettingsGroup tJobSettings = new TrackingJobSettingsGroup();
		TrackingJobSetting tJob0 = new TrackingJobSetting(null,cThreshold,new Color(255,0,0)); // locate blue label
		tJobSettings.addTrackingJobSetting(tJob0);
		TrackingJobSetting tJob1 = new TrackingJobSetting(null,cThreshold,new Color(0,255,0)); // locate green label
		tJobSettings.addTrackingJobSetting(tJob1);
		TrackingJobSetting tJob2 = new TrackingJobSetting(null,cThreshold,new Color(0,0,255)); // locate red label
		tJobSettings.addTrackingJobSetting(tJob2);

		//setup and run the tracker 
		OpenCVTracker OpenCVTrackerDemo = new OpenCVTracker("ColorTracker",camID);
		OpenCVTrackerDemo.initializeTracker(fps,secsToRun,tJobSettings,toFile,toVector,toScreen,null,null);
		OpenCVTrackerDemo.setVisible(true);
    } catch (Exception e) { e.printStackTrace(); }
    }
}
