/*
Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that this
notice appears in all copies of this software.

IN NO EVENT SHALL RH BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, 
SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE 
OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF RH HAS BEEN 
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

RH SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" 
BASIS, AND RH HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, 
UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

Online Documentation for this class can be found at
http://caspar.bgsu.edu/~software/Java/Docs/
 */

package Tests_Tracker;

import com.lobsterman.JavaGrinders.JavaGrinders;
//import com.lobsterman.JavaGrinders.Tracker.AVIProducer;
//import com.lobsterman.JavaGrinders.Tracker.MovieFrameRenderer;
import com.lobsterman.JavaGrinders.Tracker.OpenCVRecordProc;

import java.awt.Rectangle;

import com.lobsterman.JavaGrinders.Tracker.OpenCVTracker;
import com.lobsterman.JavaGrinders.Tracker.TrackingJobSetting;
import com.lobsterman.JavaGrinders.Tracker.TrackingJobSettingsGroup;
/*import com.lobsterman.JavaGrinders.control.DeviceManager;
import com.lobsterman.JavaGrinders.control.UVCDeviceManager;

import cl.cc.jlibuvc.UVCController;
import cl.cc.jlibuvc.UVCController.UVCDevice;
import cl.cc.jlibuvc.UVCController.UVCDeviceHandle;
import cl.cc.jlibuvc.UVCController.UVCError;*/

/**
 * demo class to control the sequence grabber classes for tracking objects in specific parts of the window
 *
 * @author  <a href="mailto:lobsterman.bgsu@gmail.com">RH</a>
 * @Version	@(#)OpenCVTracker_full.java 1/12/16
 */
public class CVTracker_full {

	static int camID = 0;
	static int pixelThreshold = 30;
	static int objectSize = 900;
	static boolean darkObject = false;
	static int secsToRun = -1;
	static boolean toFile = false;
	static boolean toVector = false;
	static boolean toScreen = true;
	static float fps = 30;
	static boolean configureCamera = false;
	public static int focusDist = 20;
	public static int apertureTime = 10000;

	/** 
	 * the main function of the class
	 *
	 * @param args Unused
	 */
	public static void main (String args[]) {
		try {
			//System.out.println("This demo application attempts to track a dark object in the frame for 15 seconds at 30fps."); 
			//System.out.println("Change settings in file 'OpenCVTracker_simple.java'");
			//JavaGrinders.listDebug = true;
			JavaGrinders.listDetail = true;

			//create a track job
			TrackingJobSettingsGroup trackJGroup = new TrackingJobSettingsGroup();
			trackJGroup.addTrackingJobSetting(new TrackingJobSetting(new Rectangle(100,100,150,150),pixelThreshold,objectSize,darkObject));
			trackJGroup.addTrackingJobSetting(new TrackingJobSetting(new Rectangle(400,100,150,150),pixelThreshold,objectSize,darkObject));

			/*TrackingJobSetting tJob1 = new TrackingJobSetting(new Rectangle(400,100,150,150),pixelThreshold,objectSize,darkObject);
			trackJGroup.addTrackingJobSetting(tJob1);
			TrackingJobSetting tJob2 = new TrackingJobSetting(new Rectangle(100,300,150,150),pixelThreshold,objectSize,darkObject);
			trackJGroup.addTrackingJobSetting(tJob2);
			TrackingJobSetting tJob3 = new TrackingJobSetting(new Rectangle(400,300,150,150),pixelThreshold,objectSize,darkObject);
			trackJGroup.addTrackingJobSetting(tJob3);*/

			//create a recording and analysis procedure
			OpenCVRecordProc aProc = new OpenCVRecordProc();
			aProc.plotExtended = false;			//plot simple dots for captured coordinates
			aProc.isGrayScale = true;			//run the tracker in gray scale?
			aProc.drawObject = true;			//draws the found object outline?

			//To open an instance of the OpenCV library from a specific path ...
			//String pathToLib = "/opt/local/share/OpenCV/java/libopencv_java300.dylib";
			//System.load(pathToLib);

			//create tracker
			OpenCVTracker cvTrackerDemo = new OpenCVTracker(camID);
			cvTrackerDemo.initializeTracker(fps,secsToRun,trackJGroup,toFile,toVector,toScreen,null,aProc);
			//cvTrackerDemo.setUnsharpenBeforeDetection(false);
			cvTrackerDemo.setVanishingTrail(20);

			//setup a VideoProducer with a MovieFrameRenderer
			/*AVIProducer theProducer = new AVIProducer();
			MovieFrameRenderer theRenderer = new MovieFrameRenderer();
			theProducer.setRenderer(theRenderer);
			cvTrackerDemo.setVideoProducer(theProducer);*/

			cvTrackerDemo.setVisible(true);

		} catch (Exception e) { e.printStackTrace(); }
	}
}