/*
Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that this
notice appears in all copies of this software.

IN NO EVENT SHALL RH BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, 
SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE 
OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF RH HAS BEEN 
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

RH SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" 
BASIS, AND RH HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, 
UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

Online Documentation for this class can be found at
http://caspar.bgsu.edu/~software/Java/Docs/
*/

package Tests_Tracker;

import java.awt.Rectangle;

import com.lobsterman.JavaGrinders.JavaGrinders;
import com.lobsterman.JavaGrinders.Tracker.*;

/**
 * demo class to control the sequence grabber classes for tracking objects in specific parts of the window
 *
 * @author      <a href="mailto:lobsterman.bgsu@gmail.com">RH</a>
 * @Version	@(#)OpenCVTracker_simple.java 6/6/12
 */
public class CVTracker_multiCam {
	static int camID1 = 0;
	static int camID2 = 1;
	//static int camID = 1;
	static int pixelThreshold = 30;
	static int objectSize = 900;
	static boolean darkObject = true;
	static int secsToRun = 15;
	static boolean toFile = false;
	static boolean toVector = false;
	static boolean toScreen = true;
	static float fps = 30;

    public static void main (String args[]) {
    try {
		System.out.println("This demo application attempts to track a bunch of dark objects in two different trackers."); 
		System.out.println("Change settings in file 'OpenCVTracker_Keith.java'");
		//JavaGrinders.listDebug = true;
		JavaGrinders.listDetail = true;

		//create track jobs 1
		TrackingJobSettingsGroup tjobs1Settings = new TrackingJobSettingsGroup();
		TrackingJobSetting tjobs1_0 = new TrackingJobSetting(new Rectangle(68,12,36,200),pixelThreshold,objectSize,darkObject);
		tjobs1Settings.addTrackingJobSetting(tjobs1_0);
		TrackingJobSetting tjobs1_1 = new TrackingJobSetting(new Rectangle(107,12,36,200),pixelThreshold,objectSize,darkObject);
		tjobs1Settings.addTrackingJobSetting(tjobs1_1);
		TrackingJobSetting tjobs1_2 = new TrackingJobSetting(new Rectangle(146,12,36,200),pixelThreshold,objectSize,darkObject);
		tjobs1Settings.addTrackingJobSetting(tjobs1_2);
		TrackingJobSetting tjobs1_3 = new TrackingJobSetting(new Rectangle(185,12,36,200),pixelThreshold,objectSize,darkObject);
		tjobs1Settings.addTrackingJobSetting(tjobs1_3);

		//create a recording and analysis procedure
		OpenCVRecordProc aProc = new OpenCVRecordProc();
		aProc.plotExtended = true;		//plot simple dots for captured coordinates
		aProc.isGrayScale = true;			//run the tracker in gray scale?
		
		//create tracker 1
		OpenCVTracker cvTrackerDemo1 = new OpenCVTracker("OpenCVTracker1",camID1);
		cvTrackerDemo1.initializeTracker(fps,secsToRun,tjobs1Settings,toFile,toVector,toScreen,null,aProc);
		cvTrackerDemo1.setApplyFilterBeforeDetection(false);
		cvTrackerDemo1.setVanishingTrail(20);
		cvTrackerDemo1.setVisible(true);
				
		//create track jobs 2
		TrackingJobSettingsGroup tjobs2Settings = new TrackingJobSettingsGroup();
		TrackingJobSetting tjobs2_0 = new TrackingJobSetting(new Rectangle(44,486,36,160),pixelThreshold,objectSize,darkObject);
		tjobs1Settings.addTrackingJobSetting(tjobs2_0);
		TrackingJobSetting tjobs2_1 = new TrackingJobSetting(new Rectangle(82,486,36,160),pixelThreshold,objectSize,darkObject);
		tjobs1Settings.addTrackingJobSetting(tjobs2_1);
		TrackingJobSetting tjobs2_2 = new TrackingJobSetting(new Rectangle(120,486,36,160),pixelThreshold,objectSize,darkObject);
		tjobs1Settings.addTrackingJobSetting(tjobs2_2);
		TrackingJobSetting tjobs2_3 = new TrackingJobSetting(new Rectangle(158,486,36,160),pixelThreshold,objectSize,darkObject);
		tjobs1Settings.addTrackingJobSetting(tjobs2_3);

		//create a recording and analysis procedure
		OpenCVRecordProc aProc2 = new OpenCVRecordProc();
		aProc2.plotExtended = true;		//plot simple dots for captured coordinates
		aProc2.isGrayScale = true;			//run the tracker in gray scale?
		
		//create tracker 2
		OpenCVTracker cvTrackerDemo2 = new OpenCVTracker("OpenCVTracker2",camID2);
		cvTrackerDemo2.initializeTracker(fps,secsToRun,tjobs2Settings,toFile,toVector,toScreen,null,aProc);
		cvTrackerDemo2.setApplyFilterBeforeDetection(false);
		cvTrackerDemo2.setVanishingTrail(20);
		cvTrackerDemo2.setVisible(true);	

    } catch (Exception e) { e.printStackTrace(); }
    }
}