/*
Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that this
notice appears in all copies of this software.

IN NO EVENT SHALL RH BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, 
SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE 
OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF RH HAS BEEN 
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

RH SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT 
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" 
BASIS, AND RH HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, 
UPDATES, ENHANCEMENTS, OR MODIFICATIONS.

Online Documentation for this class can be found at
http://caspar.bgsu.edu/~software/Java/Docs/
 */

package Tests_Tracker;

import com.lobsterman.JavaGrinders.JavaGrinders;

//import java.awt.Rectangle;

import com.lobsterman.JavaGrinders.Tracker.OpenCVTracker;
import com.lobsterman.JavaGrinders.Tracker.TrackingJobSetting;
import com.lobsterman.JavaGrinders.Tracker.TrackingJobSettingsGroup;

/**
 * demo class to control the sequence grabber classes for tracking objects in specific parts of the window
 *
 * @author <a href="mailto:lobsterman.bgsu@gmail.com">RH</a>
 * @Version	6/6/12
 */
public class CVTracker_simple {
	static int camID = 0;
	static int pixelThreshold = 30;
	static int objectSize = 10000;
	static boolean darkObject = true;
	static int secsToRun = -1;
	static boolean toFile = false;
	static boolean toVector = false;
	static boolean toScreen = true;
	static float fps = 30;

	public static void main (String args[]) {
		try {
			//System.out.println("This demo application attempts to track a dark object in the frame for 15 seconds at 30fps."); 
			//System.out.println("Change settings in file 'OpenCVTracker_simple.java'");
			JavaGrinders.listDetail = true;

			//create a track job
			TrackingJobSettingsGroup trackJGroup = new TrackingJobSettingsGroup();
			TrackingJobSetting tJob0 = new TrackingJobSetting(null,pixelThreshold,objectSize,darkObject);
			trackJGroup.addTrackingJobSetting(tJob0);

			//create tracker
			OpenCVTracker cvTrackerDemo = new OpenCVTracker(camID);
			cvTrackerDemo.initializeTracker(fps,secsToRun,trackJGroup,toFile,toVector,toScreen,null,null);
			cvTrackerDemo.setVisible(true);

		} catch (Exception e) { e.printStackTrace(); }
	}
}